diff -Nrc2 fontutils-0.5/gsrenderfont/input-pbm.c fontutils-0.6/gsrenderfont/input-pbm.c
*** fontutils-0.5/gsrenderfont/input-pbm.c	Tue Apr 21 07:49:06 1992
--- fontutils-0.6/gsrenderfont/input-pbm.c	Fri Oct 23 15:07:45 1992
***************
*** 56,67 ****
    pbm_input_file = NULL;
  }
- 
- 
  
! /* Read a block HEIGHT scanlines high from the image.  The last few
!    scanlines must all be blank (we don't bother to return them).  If
!    they aren't, then a rounding error has caused Ghostscript to give us
!    fewer lines than expected.  Just return a short block, and save that
!    line for next time.  */
  
  /* The constant here must match that in writefont.PS's calculation of
--- 56,66 ----
    pbm_input_file = NULL;
  }
  
! /* Read a block exactly HEIGHT scanlines high from the image.  The last
!    few scanlines must all be blank (we don't bother to return them).  If
!    they aren't, then something is wrong.  A rounding error has caused
!    Ghostscript to give us fewer lines than expected.  Just return a
!    short block, and save the first nonblank line (we don't read past the
!    first) for next time.  */
  
  /* The constant here must match that in writefont.PS's calculation of
***************
*** 72,83 ****
  pbm_get_block (unsigned height)
  {
-   static boolean at_eof = false;
-   static int image_format;
-   static int image_height;
    static int image_width = -1;
    static one_byte *saved_scanline = NULL;
    int c;
!   one_byte *block, *row;
!   unsigned block_height;
    bitmap_type *b = XTALLOC1 (bitmap_type);
  
--- 71,83 ----
  pbm_get_block (unsigned height)
  {
    static int image_width = -1;
    static one_byte *saved_scanline = NULL;
+   static one_byte *blank_row;
+   static int image_format;
+   static int image_height;
    int c;
!   one_byte *row;
!   one_byte *block;
!   unsigned block_height, blank;
    bitmap_type *b = XTALLOC1 (bitmap_type);
  
***************
*** 84,105 ****
    /* Initialize the PBM info if necessary.  */
    if (image_width == -1)
-     pbm_readpbminit (pbm_input_file, &image_width, &image_height,
-                      &image_format);
- 
-   if (at_eof)
-     return NULL;
-     
-   /* If we have a saved scanline, let that start us off.  */
-   if (saved_scanline)
-     {
-       block = saved_scanline;
-       block_height = 1;
-     }
-   else
      {
!       block = NULL;
!       block_height = 0;
      }
  
    /* Attach rows until we get to an all-white row that is after row #
       `height - BLANK_COUNT'.  */
--- 84,98 ----
    /* Initialize the PBM info if necessary.  */
    if (image_width == -1)
      {
!       pbm_readpbminit (pbm_input_file, &image_width, &image_height,
!                        &image_format);
!       blank_row = xmalloc (image_width);
      }
  
+ 
+   /* If we have a saved scanline, let that start us off.  */
+   block = saved_scanline;
+   block_height = !!block;
+ 
    /* Attach rows until we get to an all-white row that is after row #
       `height - BLANK_COUNT'.  */
***************
*** 106,109 ****
--- 99,110 ----
    do
      {
+       /* If we're at the end of the file, quit.  Presumably there was
+          one last blank row at the end or something.  If something was
+          seriously wrong, it'll manifest itself later.  */
+       c = getc (pbm_input_file);
+       if (c == EOF)
+         return NULL;
+       ungetc (c, pbm_input_file);
+ 
        block_height++;
        block = xrealloc (block, block_height * image_width);
***************
*** 111,145 ****
        get_row (row, image_width, image_format);
      }
!   while (!(block_height > height - BLANK_COUNT
!            && memchr (row, BLACK, image_width) == NULL));
  
!   /* Skip more all-blank rows.  We can keep using `row' as our buffer,
!      since it just points to the all-blank row we found; we won't be
!      including it in the bitmap we return.  We might hit the end of the
!      image here, in which case we just stop.  */
!   do
      {
        c = getc (pbm_input_file);
!       at_eof = c == EOF;
  
!       if (!at_eof)
!         {
!           ungetc (c, pbm_input_file);
!           get_row (row, image_width, image_format);
!         }
      }
!   while (!at_eof && memchr (row, BLACK, image_width) == NULL);
!   
!   /* If we are not at eof, save the nonblank row we found to start us
!      off next time.  */
!   if (!at_eof)
      {
        saved_scanline = xmalloc (image_width);
!       memcpy (saved_scanline, row, image_width);
      }
! 
    /* Fill in the bitmap to return.  */
    BITMAP_WIDTH (*b) = image_width;
!   BITMAP_HEIGHT (*b) = block_height - 1;
    BITMAP_BITS (*b) = block;
  
--- 112,147 ----
        get_row (row, image_width, image_format);
      }
!   while (block_height <= height - BLANK_COUNT
!          || memchr (row, BLACK, image_width));
  
!   /* Skip the next BLANK_COUNT rows (they had better be blank).  We can
!      keep using `row' as our buffer, since it just points to the
!      all-blank row we found; we won't be including it in the bitmap we
!      return.  We might hit the end of the image here, in which case we
!      just stop.  */
!   for (blank = 1; blank < BLANK_COUNT; blank++)
      {
        c = getc (pbm_input_file);
!       if (c == EOF)
!         break;
!         
!       ungetc (c, pbm_input_file);
!       get_row (blank_row, image_width, image_format);
  
!       if (memchr (blank_row, BLACK, image_width) != NULL)
!         break;
      }
! 
!   if (blank == BLANK_COUNT)
!     saved_scanline = NULL;
!   else
      {
        saved_scanline = xmalloc (image_width);
!       memcpy (saved_scanline, blank_row, image_width);
      }
!   
    /* Fill in the bitmap to return.  */
    BITMAP_WIDTH (*b) = image_width;
!   BITMAP_HEIGHT (*b) = block_height;
    BITMAP_BITS (*b) = block;
  
diff -Nrc2 fontutils-0.5/gsrenderfont/main.c fontutils-0.6/gsrenderfont/main.c
*** fontutils-0.5/gsrenderfont/main.c	Fri Jun  5 09:20:26 1992
--- fontutils-0.6/gsrenderfont/main.c	Fri Oct 23 07:09:46 1992
***************
*** 57,61 ****
     Ghostscript.  So this program reads an image, counts the bounding
     boxes in each character, and writes another file with the bounding
!    box counts.  */
  
  #define PROGRAM_NAME "bbcount"
--- 57,66 ----
     Ghostscript.  So this program reads an image, counts the bounding
     boxes in each character, and writes another file with the bounding
!    box counts.
!    
!    We assume that all characters occupy the same number of scanlines; we
!    simply read that constant number for each character.  We can't put
!    other marks in the image to avoid this assumption, since then Imageto
!    will have to contend with t.  */
  
  #define PROGRAM_NAME "bbcount"
***************
*** 70,96 ****
    string font_name = read_command_line (argc, argv);
    
!   /* Since we have to read two input files, we just throw away any
!      extension they give us.  This doesn't support filenames like
!      `a.b.pbm'.  */
!   string font_basename = basename (font_name);
!   if (font_basename != font_name)
!     WARNING2 ("%s: Ignoring extension on `%s'", PROGRAM_NAME, font_name);
  
    /* Open the image input file.  */
!   pbm_open_input_file (concat (font_basename, ".pbm"));
    
    /* Read the information about that image file.  */
!   bfi = read_bfi_file (concat (font_basename, ".bfi"));
  
    if (output_name == NULL)
!     output_name = font_basename;
! 
!   output_name =  extend_filename (output_name, "bbs");
                      
-   bbs_file = xfopen (output_name, "w");
- 
    while ((b = pbm_get_block (bfi.char_height)) != NULL)
      {
!       bounding_box_list_type boxes = find_outline_bbs (*b, false, 0, 0);
        fprintf (bbs_file, "%d\n", BB_LIST_LENGTH (boxes));
        
--- 75,102 ----
    string font_name = read_command_line (argc, argv);
    
!   /* We have to read two input files, but they might have given us a
!      suffix on the PBM file, so we have to remove it for the BFI.  This
!      doesn't support filenames like `a.b.pbm'.  */
  
    /* Open the image input file.  */
!   pbm_open_input_file (extend_filename (font_name, "pbm"));
    
    /* Read the information about that image file.  */
!   bfi = read_bfi_file (make_suffix (font_name, "bfi"));
  
    if (output_name == NULL)
!     {
!       bbs_file = stdout;
!       report_file = stderr;
!     }
!   else
!     {
!       output_name =  make_suffix (output_name, "bbs");
!       bbs_file = xfopen (output_name, "w");
!     }
                      
    while ((b = pbm_get_block (bfi.char_height)) != NULL)
      {
!       bb_list_type boxes = find_outline_bbs (*b, false, 0, 0);
        fprintf (bbs_file, "%d\n", BB_LIST_LENGTH (boxes));
        
***************
*** 139,145 ****
  "help: print this message.
  output-file <filename>: write to <filename>.bbs if <filename> has no
!   suffix, and to <filename> if it has.  Default is the concatenation of
!   <font_name> with the size removed (e.g., for `cmr10' it would be `cmr')
!   and `.bbs'.
  trace-scanlines: show every scanline as we read it.
  verbose: output progress reports to stderr.
--- 145,149 ----
  "help: print this message.
  output-file <filename>: write to <filename>.bbs if <filename> has no
!   suffix, and to <filename> if it has.  Default is standard output.
  trace-scanlines: show every scanline as we read it.
  verbose: output progress reports to stderr.
***************
*** 183,187 ****
        
        else if (ARGUMENT_IS ("version"))
!         printf ("%s.\n", version_string);
  
        /* Else it was a flag; getopt has already done the assignment.  */
--- 187,191 ----
        
        else if (ARGUMENT_IS ("version"))
!         fprintf (stderr, "%s.\n", version_string);
  
        /* Else it was a flag; getopt has already done the assignment.  */
diff -Nrc2 fontutils-0.5/gsrenderfont/version.c fontutils-0.6/gsrenderfont/version.c
*** fontutils-0.5/gsrenderfont/version.c	Thu Sep  3 09:46:20 1992
--- fontutils-0.6/gsrenderfont/version.c	Tue Oct 27 13:27:59 1992
***************
*** 1 ****
! char *version_string = "bbcount version 0.5";
--- 1 ----
! char *version_string = "bbcount version 0.6";
